//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   SteelBlue
#property indicator_width1   2
#property indicator_level1   4
#property indicator_level2   0
#property indicator_level3  -4

//
//
//
//
//

extern int    FasterMA     = 9;
extern int    SlowerMA     = 26;
extern int    MAMode       = MODE_EMA;
extern int    MAPrice      = PRICE_CLOSE;
extern int    ADXPeriod    = 14;
extern int    ADXPrice     = PRICE_CLOSE;
extern double ADXValue     = 20;
extern double DIValues     = 25;
extern double Smooth       = 5;
extern double SmoothPhase  = 0;
extern bool   SmoothDouble = 0;

//
//
//
//
//

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double value[];
double state1[];
double state2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,state1);
   SetIndexBuffer(2,state2);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double macd = iMA(NULL,0,FasterMA,0,MAMode,MAPrice,i)-iMA(NULL,0,SlowerMA,0,MAMode,MAPrice,i);
      double adx  = iADX(NULL,0,ADXPeriod,ADXPrice,MODE_MAIN,i);
      double dip  = iADX(NULL,0,ADXPeriod,ADXPrice,MODE_PLUSDI,i);
      double dim  = iADX(NULL,0,ADXPeriod,ADXPrice,MODE_MINUSDI,i);

         double result = 0;
            if (macd>0)                             result +=1;
            if (macd<0)                             result -=1;
            if (dip>dim && dip>DIValues)            result +=1;
            if (dim>dip && dim>DIValues)            result -=1;
            if (adx>ADXValue && dip>dim)            result +=1;
            if (adx>ADXValue && dim>dip)            result -=1;
            if (adx>ADXValue && adx<dip && adx>dim) result +=1;
            if (adx>ADXValue && adx>dip && adx<dim) result -=1;
         double smoothResult = iDSmooth(result,Smooth,SmoothPhase,i);
         if (MathAbs(result) == 4)
               value[i] = result;
         else  value[i] = smoothResult;          

         //
         //
         //
         //
         //
         
         state1[i] = state1[i+1];
            if (MathAbs(result) == 4)
            {
               if (result==4) 
                     state1[i] =  1;
                else state1[i] = -1;
            }                
            else state1[i] = 0;
         state2[i] = state2[i+1];
            if (value[i]>0) state2[i] =  1;
            if (value[i]<0) state2[i] = -1;
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      static datetime alertedAt1;
      static datetime alertedAt2;
      static string alertedWhat1;
      static string alertedWhat2;
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (state1[whichBar] != state1[whichBar+1])
      {
         if (state1[whichBar] ==  1) doAlert(alertedAt1,alertedWhat1,whichBar,"long");
         if (state1[whichBar] == -1) doAlert(alertedAt1,alertedWhat1,whichBar,"short");
      }
      if (state2[whichBar] != state2[whichBar+1])
      {
         if (state2[whichBar] ==  1) doAlert(alertedAt2,alertedWhat2,whichBar,"zero line cross up");
         if (state2[whichBar] == -1) doAlert(alertedAt2,alertedWhat2,whichBar,"zero line cross down");
      }
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ","halvard signal for ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"halvard "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   if (SmoothDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}